datablock AudioProfile(RyderFireSound)
{
	filename = "./wpn_ryder_fire.wav";
	description = AudioClose3D;
	preload = true;
};

datablock AudioProfile(RyderBulletHitSound : RyderFireSound)
{
	filename = "./bulletHit.wav";
};

datablock AudioProfile(RyderSwitchInSound : RyderFireSound)
{
	filename = "./wpn_ryder_switchin.wav";
};

datablock AudioProfile(RyderReloadSound : RyderFireSound)
{
	filename = "./wpn_ryder_reload.wav";
};

datablock DebrisData(ryderShellDebris)
{
	shapeFile = "./ryderShell.dts";
	lifetime = 5.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 400.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;
	gravModifier = 1;
};

datablock ParticleData(ryderFlashParticle)
{
	dragCoefficient = 3;
	gravityCoefficient = -0.5;
	inheritedVelFactor = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS = 25;
	lifetimeVarianceMS = 15;
	textureName = "Add-Ons/Weapon_Ryder/muzzleFlash";
	spinSpeed = 10.0;
	spinRandomMin = -500.0;
	spinRandomMax = 500.0;
	colors[0] = "1.0 1.0 1.0 0.9";
	colors[1] = "1.0 1.0 1.0 0.0";
	sizes[0] = 0.5;
	sizes[1] = 1.0;
	useInvAlpha = false;
};
datablock ParticleEmitterData(ryderFlashEmitter)
{
	ejectionPeriodMS = 3;
	periodVarianceMS = 0;
	ejectionVelocity = 1.0;
	velocityVariance = 1.0;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 90;
	phiReferenceVel	= 0;
	phiVariance	= 360;
	overrideAdvance = false;
	particles = "ryderFlashParticle";

	uiName = "Ryder Flash";
};

datablock ParticleData(ryderSmokeParticle)
{
	dragCoefficient = 3;
	gravityCoefficient = -0.5;
	inheritedVelFactor = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS = 525;
	lifetimeVarianceMS = 55;
	textureName = "Add-Ons/Weapon_Ryder/smoke";
	spinSpeed = 10.0;
	spinRandomMin = -500.0;
	spinRandomMax = 500.0;
	colors[0] = "0.5 0.5 0.5 0.9";
	colors[1] = "0.5 0.5 0.5 0.0";
	sizes[0] = 0.15;
	sizes[1] = 0.15;
	useInvAlpha = false;
};

datablock ParticleEmitterData(ryderSmokeEmitter)
{
	ejectionPeriodMS = 3;
	periodVarianceMS = 0;
	ejectionVelocity = 1.0;
	velocityVariance = 1.0;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 90;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = "ryderSmokeParticle";
	uiName = "Ryder Smoke";
};


datablock ParticleData(ryderExplosionParticle)
{
	dragCoefficient = 8;
	gravityCoefficient = 0;
	inheritedVelFactor = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS = 3000;
	lifetimeVarianceMS = 400;
	textureName = "Add-Ons/Weapon_Ryder/smoke";
	spinSpeed = 0.0;
	spinRandomMin = -2.0;
	spinRandomMax = 2.0;
	colors[0] = "1.0 1.0 1.0 0.6";
	colors[1] = "0.7 0.7 0.65 0.0";
	sizes[0] = 1.25;
	sizes[1] = 3.75;
	useInvAlpha = true;
};

datablock ParticleEmitterData(ryderExplosionEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 2;
	velocityVariance = 1.0;
	ejectionOffset = 0.0;
	thetaMin = 89;
	thetaMax = 90;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = "ryderExplosionParticle";
	useEmitterColors = true;
	uiName = "Ryder Hit Dust";
};

datablock ParticleData(ryderExplosionRingParticle)
{
	dragCoefficient = 8;
	gravityCoefficient = -0.5;
	inheritedVelFactor = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS = 50;
	lifetimeVarianceMS = 35;
	textureName = "Add-Ons/Weapon_Ryder/dustParticle";
	spinSpeed = 500.0;
	spinRandomMin = -500.0;
	spinRandomMax = 500.0;
	colors[0] = "1 1 0.0 0.9";
	colors[1] = "0.9 0.0 0.0 0.0";
	sizes[0] = 1;
	sizes[1] = 0;
	useInvAlpha = false;
};

datablock ParticleEmitterData(ryderExplosionRingEmitter)
{
	lifeTimeMS = 50;
	ejectionPeriodMS = 3;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0.0;
	ejectionOffset = 0.0;
	thetaMin = 89;
	thetaMax = 90;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = "ryderExplosionRingParticle";
	useEmitterColors = true;
	uiName = "Ryder Hit Flash";
};

datablock ExplosionData(ryderExplosion)
{
	soundProfile = RyderBulletHitSound;
	lifeTimeMS = 150;
	particleEmitter = ryderExplosionEmitter;
	particleDensity = 5;
	particleRadius = 0.2;
	emitter[0] = ryderExplosionRingEmitter;
	faceViewer = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
	camShakeFreq = "10.0 11.0 10.0";
	camShakeAmp = "1.0 1.0 1.0";
	camShakeDuration = 0.5;
	camShakeRadius = 10.0;
	lightStartRadius = 2;
	lightEndRadius = 2;
	lightStartColor = "0.5 0.8 0.9";
	lightEndColor = "0 0 0";
};


AddDamageType("Ryder", '<bitmap:add-ons/Weapon_Ryder/CI_Ryder> %1', '%2 <bitmap:add-ons/Weapon_Ryder/CI_Ryder> %1', 0.2, 1);
datablock ProjectileData(ryderProjectile)
{
	projectileShapeName = "./bullet.dts";
	directDamage = 30;
	directDamageType = $DamageType::Ryder;
	radiusDamageType = $DamageType::Ryder;

	brickExplosionRadius = 0;
	brickExplosionImpact = true;
	brickExplosionForce = 10;
	brickExplosionMaxVolume = 1;
	brickExplosionMaxVolumeFloating = 2;

	impactImpulse = 400;
	verticalImpulse = 400;
	explosion = ryderExplosion;
	particleEmitter = "";

	muzzleVelocity = 90;
	velInheritFactor = 1;

	armingDelay = 00;
	lifetime = 4000;
	fadeDelay = 3500;
	bounceElasticity = 0.5;
	bounceFriction = 0.20;
	isBallistic = false;
	gravityMod = 0.0;

	hasLight = false;
	lightRadius = 3.0;
	lightColor = "0 0 0.5";

	uiName = "Ryder Bullet";
};

datablock ItemData(RyderItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./ryder.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Ryder";
	iconName = "./Icon_Ryder";
	doColorShift = false;

	image = ryderImage;
	canDrop = true;
};

datablock ShapeBaseImageData(ryderImage)
{
	shapeFile = "./ryder.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0;
	rotation = eulerToMatrix( "0 0 0" );

	correctMuzzleVector = true;
	className = "WeaponImage";

	item = RyderItem;
	ammo = " ";
	projectile = ryderProjectile;
	projectileType = Projectile;

	casing = ryderShellDebris;
	shellExitDir = "1.0 -1.3 1.0";
	shellExitOffset = "0 0 0";
	shellExitVariance = 15.0;
	shellVelocity = 7.0;

	melee = false;
	armReady = true;

	doColorShift = false;

	stateName[0] = "Activate";
	stateTimeoutValue[0] = 1.0;
	stateWaitForTimeout[0] = true;
	stateTransitionOnNoAmmo[0] = "Ready";
	stateTransitionOnTimeout[0] = "Ready";
	stateScript[0] = "onActivate";
	stateSequence[0] = "Switch_In";

	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1] = true;
	stateSequence[1] = "Ready";
	stateScript[1] = "onReady";

	stateName[2] = "Fire";
	stateTransitionOnTimeout[2] = "Smoke";
	stateTimeoutValue[2] = 0.14;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateSequence[2] = "Fire";
	stateScript[2] = "onFire";
	stateWaitForTimeout[2] = true;
	stateEmitter[2] = ryderFlashEmitter;
	stateEmitterTime[2] = 0.05;
	stateEmitterNode[2] = "muzzleNode";
	stateSound[2] = RyderFireSound;
	stateEjectShell[2] = true;

	stateName[3] = "Smoke";
	stateEmitter[3] = ryderSmokeEmitter;
	stateEmitterTime[3] = 0.05;
	stateEmitterNode[3] = "muzzleNode";
	stateTimeoutValue[3] = 0.01;
	stateTransitionOnTimeout[3] = "Reload";

	stateName[4] = "Reload";
	stateTransitionOnTriggerUp[4] = "Ready";
	stateSequence[4] = "Ready";
};

datablock ShapeBaseImageData(ryderReloadImage : ryderImage)
{
	projectile = "";
	stateName[0] = "Activate";
	stateTimeoutValue[0] = 0;
	stateWaitForTimeout[0] = false;
	stateWaitFortimeout[0] = false;
	stateTransitionOnNoAmmo[0] = "";
	stateTransitionOnTimeout[0] = "Fire";
	stateSequence[0] = "";

	stateTransitionOnTriggerDown[1] = "";
	
	stateName[2] = "Fire";
	stateTransitionOnTimeout[2] = "Reload";
	stateTimeoutValue[2] = 0;
	stateFire[2] = false;
	stateAllowImageChange[2] = true;
	stateSequence[2]  = "Reload";
	stateScript[2] = "onComplete";
	stateWaitForTimeout[2] = false;
	stateEmitter[2] = "";
	stateEmitterTime[2] = "";
	stateEmitterNode[2] = "";
	stateEjectShell[2] = false;
	stateSound[2] = "";
};

function ryderImage::onMount(%this, %obj, %slot)
{
	announce("ryderImage says hi");
	if(%obj.ryderAmmo $= "")
	{
		%obj.ryderAmmo = 8;
	}

	if(!%obj.ryderImageSwitching)
	{
		%obj.playAudio(2, RyderSwitchInSound);
		%obj.playThread(2, shiftRight);
		%obj.ryderSchedule[0] = %obj.schedule(450, playThread, 2, shiftLeft);
		%obj.ryderSchedule[1] = %obj.schedule(700, playThread, 2, plant);
	}

	else
	{
		%obj.ryderAmmo = 8;
	}

	%obj.displayRyderPrint();
	Parent::onMount(%this, %obj, %slot);
}

function Player::cancelRyderSchedules(%this)
{
	for(%a = 0; %this.ryderSchedule[%a] !$= ""; %a++)
	{
		cancel(%this.ryderSchedule[%a]);
		announce("cancellin' " @ %a);
	}

	%this.setRyderImageSwitching(0);
}

function ryderImage::onUnMount(%this, %obj, %slot)
{
	%obj.stopAudio(2);
	%obj.cancelRyderSchedules();

	Parent::onMount(%this, %obj, %slot);
}

function ryderReloadImage::onUnMount(%this, %obj, %slot)
{
	announce("\c4" @ %obj.ryderImageSwitching);
	if(!%obj.ryderImageSwitching)
	{
		announce("\c4ok nope, so cancelling");
		%obj.stopAudio(2);
		%obj.cancelRyderSchedules();
	}

	Parent::onMount(%this, %obj, %slot);
}

function ryderImage::onFire(%this, %obj, %slot)
{
	if(%obj.ryderAmmo $= "")
	{
		%obj.ryderAmmo = 8;
	}
	if(%obj.ryderAmmo <= 1)
	{
		%obj.ryderAmmo = 0;
		%obj.unmountImage(%slot);
		%obj.mountImage(ryderReloadImage, %slot);
	}
	else
	{
		if(%obj.getDamagePercent() < 1.0)
		{
			//%obj.playThread(2, shiftAway);
			%obj.playThread(3, plant);
		}
		Parent::onFire(%this,%obj,%slot);
		%obj.ryderAmmo--;
	}
	%obj.displayRyderPrint();
}

function ryderImage::onReady(%this, %obj, %slot)
{
	%obj.setImageAmmo(0, 1);
}

function ryderReloadImage::onComplete(%this, %obj, %slot)
{
	announce("onComplete ryder reload");
	%obj.playAudio(2, RyderReloadSound);

	%obj.ryderSchedule[2] = %obj.schedule(300, playThread, 2, shiftLeft);
	%obj.ryderSchedule[3] = %obj.schedule(1000, playThread, 2, shiftTo);
	%obj.ryderSchedule[4] = %obj.schedule(1400, playThread, 2, shiftRight);
	%obj.ryderSchedule[5] = %obj.schedule(1900, playThread, 2, plant);

	%obj.ryderSchedule[6] = %obj.schedule(2500, setRyderImageSwitching, 1);
	%obj.ryderSchedule[7] = %obj.schedule(2500, unmountImage, %slot);
	%obj.ryderSchedule[8] = %obj.schedule(2500, mountImage, ryderImage, %slot, true);
	%obj.ryderSchedule[8] = %obj.schedule(2500, setImageAmmo, 0, 0);
	%obj.ryderSchedule[9] = %obj.schedule(2500, setRyderImageSwitching, 0);
}

function Player::setRyderImageSwitching(%this, %val)
{
	announce("setRyderImageSwitching " @ %val);
	%this.ryderImageSwitching = %val;
}

function Player::displayRyderPrint(%this)
{
	bottomPrint(%this.client, "<just:right><font:impact:24><color:fff000>Ryder <font:impact:34>\c6" @ %this.ryderAmmo @ " / " @ 8, 1);
}

if(isPackage(RyderPackage))
{
	deactivatePackage(RyderPackage);
}

package RyderPackage
{
	function serverCmdLight(%this)
	{
		if(isObject(%obj = %this.player))
		{
			if(%obj.getMountedImage(0).getName() $= "ryderImage")
			{
				if(%obj.ryderAmmo < 8)
				{
					%obj.unmountImage(%slot);
					%obj.mountImage(ryderReloadImage, %slot);
					%obj.ryderAmmo = 0;
				}
				%obj.displayRyderPrint();
				return;
			}
		}
		Parent::serverCmdLight(%this);
	}
};

activatePackage(RyderPackage);